program vector_ballz;                   { coded by Fusion / RaM   }
                                        { for internal use only!! }
                                        { idea by KRASh! Thnx !!! }
const
        obj : array[1..44, 1..2] of integer =
              (
      {f}     (-40,20),(-50,20),(-60,20),(-70,20),(-80,20),
              (-80,10),(-80,0),(-70,0),(-60,0),(-50,0),(-80,-10),
              (-80,-20),
      {o}     (20,20),(10,20),(0,20),(-10,20),(-20,20),(-20,10),
              (-20,0),(-20,-10),(-20,-20),(-10,-20),(0,-20),(10,-20),
              (20,-20),(20,-10),(20,0),(20,10),
      {m}     (80,-20),(80,-10),(80,0),(80,10),(80,20),(70,20),
              (60,20),(50,20),(40,20),(40,10),(40,0),(40,-10),
              (40,-20),(60,10),(60,0),(60,-10)
              );
type    point = record
                x, y, z : real;
                end;
        virtual = array[1..64000] of byte;
        ball  = array[-11..11,-11..11] of byte;

var     translated : array[1..44] of point;
        table : array[0..360, 1..2] of real;
        v_screen : ^virtual;
        v_seg : word;
        c:word;
        xp,yp,zp,zp2:array[1..44] of integer;
        pind:array[1..44] of word;
        circles:array[1..11] of ball;
        deg,deg2:word;
        YTable:array[0..199] of word;

procedure shadedsphere(Kd,Ks:real;Specindex,radius:integer);
const
     Ilight=100;
     K=0.2;
     IaKa=0.8;
     Hx=0.325058; Hy=0.325058; Hz=0.888074;
     dx=110.0; dy=110.0; dz=110.0;
     Lx=0.57735; Ly=0.57735; Lz=0.57735;
var
     Ig,Irb,x,y,z:integer;
     rsquare,xsquare,ysquare,zsquare,denom,xn,yn,zn,
     LdotN,NnH,dist,distfactor,ambientterm,diffuseterm,
     specularterm:real;

     procedure CalculateLNandNnH(x,y,z,SpecIndex:integer;
               xn,yn,zn:real;var LdotN,dist,NnH:real);
     var
        NH:real;
     begin
          LdotN:=xn*Lx+yn*Ly+zn*Lz;
          if LdotN <= 0.0 then LdotN := 0.0
          else
          begin
               dist:=sqrt(sqr(dx-x)+sqr(dy-y)+sqr(dz-z));
               NH:=Hx*xn+Hy*yn+Hz*zn;
               NnH:=exp(SpecIndex*ln(NH));
          end;
     end;

     begin
          rsquare:=sqr(radius);
          for y:=-radius to radius do
          begin
               ysquare:=sqr(y);
               for x:=-radius to radius do
               begin
                    xsquare:=sqr(x);
                    if (xsquare+ysquare)<=rsquare then
                    begin
                         z:=round(sqrt(rsquare-xsquare-ysquare));
                         zsquare:=sqr(z);
                         denom:=sqrt(xsquare+ysquare+zsquare);
                         xn:=x/denom;yn:=y/denom;zn:=z/denom;
                         CalculateLNandNnH(x,y,z,SpecIndex,xn,yn,
                                           zn,LdotN,dist,NnH);
                         ambientterm:=IaKa;
                         if LdotN <= 0.0 then
                         begin
                              Ig:=round(63*ambientterm);
                              Irb:=0;
                         end
                         else
                         begin
                              distfactor:=Ilight/(dist+K);
                              diffuseterm:=distfactor*Kd*LdotN;
                              specularterm:=distfactor*Ks*NnH;
                              Ig:=round(63*(ambientterm+diffuseterm+
                                             specularterm));
                              Irb:=round(63*specularterm);
                         end;
                    if Irb>255 then Irb:=255;
                    if Ig>255 then Ig:=255;
{                    setpixel(XCentre+x,YCentre+y,Irb,Ig,Irb,v_seg);}
                    Circles[radius][x,y]:=(Irb+Ig) shr 1;
               end;
          end;
     end;
end;

procedure wait_retrace;assembler;
asm
   mov  dx,3dah
@wait1:
   in   al,dx
   test al,8h
   jnz  @wait1
@wait2:
   in   al,dx
   test al,8h
   jz   @wait2
   ret
end;

procedure cls(segment : word);assembler;
asm
   mov  es,[segment]
   db $66;xor  di,di
   db $66;xor ax,ax
   mov  cx,16000
   db $66; rep  stosw
end;

procedure switch(source, dest : word);assembler;
asm
   push ds
   mov  ax,[dest]
   mov  es,ax
   mov  ax,[source]
   mov  ds,ax
   db $66;xor  si,si
   db $66;xor  di,di
   mov  cx,16000
   db $66; rep  movsw
   pop  ds
end;

procedure dopal(c,r,g,b:byte); assembler; asm
  mov dx,3c8h; mov al,[c]; out dx,al; inc dx; mov al,[r]
  out dx,al; mov al,[g]; out dx,al; mov al,[b]; out dx,al; end;

procedure rotatepoints (x, y, z : integer);
var
c : word;
te1:real;
begin
       for c := 1 to 44 do begin
         translated[c].x := obj[c,1];
         translated[c].y := obj[c,2]*table[x,2];
         translated[c].z := obj[c,2]*table[x,1];

         te1:=translated[c].z;

         translated[c].x := (translated[c].x*table[y,2]+translated[c].z*table[y,1]);
         translated[c].z := (-obj[c,1]*table[y,1]+te1*table[y,2]);

         te1:=translated[c].x;

         translated[c].x := (translated[c].x*table[z,2]-translated[c].y*table[z,1]);
         translated[c].y := (te1*table[z,1]+translated[c].y*table[z,2]);

     end;
end;

procedure quicksort(lo,hi : integer);
procedure sort(l,r : integer);
var
   i,j,x,y : integer;
begin
     i := l; j := r; x := zp2[(l + r) shr 1];
     repeat
     while zp2[i] < x do inc(i);
     while x < zp2[j] do dec(j);
     if i <= j then begin
        y := zp2[i]; zp2[i] := zp2[j]; zp2[j] := y;
        y := pind[i]; pind[i] := pind[j]; pind[j] := y;
        inc(i); dec(j);
     end;
     until i > j;
     if l < j then sort(l,j);
     if i < r then sort(i,r);
end;
begin
  sort(lo,hi);
end;

procedure drawball(x,y,numba,segment:word);assembler;
     asm
        mov     es,segment
        mov     ax,320
        mov     bx,y
        sub     bx,Numba
        mul     bx
        add     ax,x
        sub     ax,Numba
        mov     di,ax
        mov     ax,529
        mov     bx,numba
        or      bx,bx
        jz      @exit
        dec     bx
        mul     bx
        mov     si,offset Circles
        add     si,ax
        mov     dx,23
@loop0: mov     cx,23
@loop1: mov     al,ds:[si]
        or      al,al
        jz      @next
        mov     es:[di],al
@next:  inc     di
        inc     si
        dec     cx
        jnz     @loop1
        add     di,297
        dec     dx
        jnz     @loop0
@exit:
end;

procedure drawpoints;
var    c,i:integer;te1:real;
begin
     for c := 1 to 44 do begin
         te1:=translated[c].z-105;
         xp[c]:=round(128*translated[c].x / te1);inc(xp[c],160);
         yp[c]:=round(128*translated[c].y / te1);inc(yp[c],100);
         i:=round(translated[c].z);
         zp2[c]:=i;
         zp[c]:=(i+96) shr 4;
         if xp[c]>309 then xp[c]:=309;
         if xp[c]<10 then xp[c] :=10;
         if yp[c]>189 then yp[c]:=189;
         if yp[c]<10 then yp[c] :=10;
         pind[c]:=c;
     end;
     quicksort(1,44);
     for c:=1 to 44 do drawball(xp[pind[c]],yp[pind[c]],zp[pind[c]],v_seg);
end;

begin
  asm
     mov        ax,3
     int        10h
  end;
  writeln;write('PReCaLCuLaTiNG PHoNG-BaLLS ');
  write('-[');for c:=1 to 11 do Write('');write(']-');
  asm
     mov ah,2
     xor bh,bh
     mov dh,1
     mov dl,1eh
     int 10h
  end;
  getmem(v_screen, 64000);
  v_seg := seg(v_screen^);
  for c := 0 to 360 do begin
      table[c, 1] := sin (c* pi / 180);
      table[c, 2] := cos (c* pi / 180);
  end;
  for c:=1 to 11 do begin
      shadedsphere(3.7253524,2.34126354,20,c);
      write('');
  end;
  deg2:=180;
  cls(v_seg);
  asm
     mov  ax,13h
     int  10h
  end;
  for c:=0 to 255 do dopal(c,c div 4,0,c div 4);
  for c:=0 to 199 do Ytable[c]:=c*320;
  repeat
        drawpoints;
        wait_retrace;
        switch(v_seg, $a000);
        cls(v_seg);
        rotatepoints(deg, deg2, deg);
        deg := (deg + 1) mod 360;
        deg2 := (deg2 + 1) mod 360;
  until port[$60]<127;
  asm
     mov  ax,3h
     int  10h
  end;
  freemem(v_screen, 64000);
end.
